<?php
//Variables importantes
$webp_name='WEBP_HYPERVISOR';
$webp_name_path='virtualization';

$password_hidden = '*********';

/*
- setName
- Test boutton


Remplacer online par status
et mettre online a la place de true

Mete autant sur X gigas
*/

//Inclusion des librairies importantes
$path = $_SERVER['DOCUMENT_ROOT'];

include_once $path.'/common.php';
include_once $path.'/Model_adm.php';

if($user->getDroits($dbconnection,"esia_administration") !=1 || $user->getDroits($dbconnection,"esia_device") != 1 )
{
    $smarty->display('no_access.html');
    exit(0);
}

//Variables utilisées partout
$webp_model='model_'.$webp_name_path.'.php';

//Récupération du node_id et de l'advance_id
$adv_config_id = $_REQUEST['id'];
if(!isset($_REQUEST['node']))
{
    $setting = Model_adm::getAdvanceNodeConfig($dbconnection,NULL,$adv_config_id)[0];
    $node_id = $setting['node_id'];
}
else
{
    $node_id = $_REQUEST['node'];
}
$_GET['nodeid']=$node_id;

//Include du common_node_control
include_once $path.'/inc/common_node_control.php';
$webp_template = $template_path.'/adv_'.$webp_name_path.'.html';

//Identification du type de noeud
$device_type = $node->getType();
if( $device_type == Model_virtualization::getClusterDeviceType() )
{
    $virt_type = 'cluster';
}
else
{
	$virt_type = 'hypervisor';
}

//Récupération des autres paramètres de la requête
$action 		= getRequestParam('action','list',TRUE);
if( $virt_type == 'cluster' )
{
    $driver_select	 = getRequestParam('driver','',TRUE);
    $fromRequestParams['cluster'] = getRequestParam('cluster',NULL);
}
else
{
	$cluster_select	 = getRequestParam('cluster','',TRUE);
	$nodename_select = getRequestParam('nodename','',TRUE);
}

$fromRequestParams['url'] 		=	getRequestParam('url',NULL);
$fromRequestParams['login'] 	=	getRequestParam('login',NULL);
$fromRequestParams['password']	=	getRequestParam('password',NULL);

if( $fromRequestParams['url'] == NULL ) //Alors pas de $fromRequestParams
{
    $fromRequestParams = array();
}


//Récupération des paramètres en base de donnée
try
{
    $fromDatabaseParams = Model_virtualization::getAuthenticationParams($dbconnection,$node_id);
    $nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);

    if(!empty($nodes_link))
    {
    	$nodes_link = array_shift($nodes_link); //Avec 'cluster' ou avec 'hypervisor', on a besoin que d'un seul node (uniquement celui du node en cours est récupéré en cas 'hypervisor)
    }

    //On initialise les variables si elles ne le sont pas déjà via la request
    if( $virt_type == 'cluster' && !empty($fromDatabaseParams['driver']) ) //On force le driver déja enregistré si il y en a un
    {
    	$driver_select = $fromDatabaseParams['driver'];
    }

    if( $virt_type == 'hypervisor' )
    {
    	if(!empty($nodes_link))
    	{
    		if( empty($cluster_select) )
    		{
    			$cluster_select = $nodes_link['cluster_id'];
    		}
    		if( empty($nodename_select) )
    		{
    			$nodename_select = $nodes_link['hypervisor_name'];
    		}
    	}
    	if( empty($driver_select)  && !empty($cluster_select) )
    	{
    		$driver_select = Model_virtualization::getClusterDriver($dbconnection,$cluster_select)['name'];
    	}
    }
}
catch(Exception $ex)
{
    $ret['name'] = $ex->getName();
    $ret['message'] = $ex->getMessage();
    $errors[] = $ret;
}

//Configuration des paramètres à changer
$savingParams = array();

$is_changed = FALSE;
if( empty(  $fromDatabaseParams ) )
{
    $is_added = FALSE;
	$savingParams = $fromRequestParams;
	$is_changed = TRUE;
}
else
{
    $is_added = TRUE;
    if(!empty($fromRequestParams))
    {
    	if($fromRequestParams['password'] == $password_hidden )
    	{
    		$fromRequestParams['password'] = $fromDatabaseParams['password'];
    	}
    	$fromRequestParams['driver'] = $driver_select;
    }

    $keys = 'url,login,password,cluster';
	foreach(explode(',',$keys) as $key)
	{
		if( $fromRequestParams[$key] != $fromDatabaseParams[$key] )
		{
			$savingParams[$key] = $fromRequestParams[$key];
			$is_changed = TRUE;
		}
	}
}
$savingParams['driver'] = $driver_select;

//Configuration des paramètres lang
if( !empty($driver_select) )
{
    $lang = $lang[$driver_select];
    $smarty->assign('lang',$lang);
}

//On effectue une action si nécessaire
if( $action == "test" || $action == 'update_conf' )
{
		$ret['name'] = 'DEVICE UNREACHEABLE';
    	$ret['message'] = $lang['VIRT_ADV_UNREACHEABLE_DATA'];

	    try
		{
		    Model_virtualization::testDriver($dbconnection,$fromRequestParams,$driver_select);
            $ret['name'] = '';
            $ret['message'] = $lang['VIRT_ADV_REACHEABLE_DEVICE'];
            $messages[] = $ret;
		}
		catch (Exception $e) {
		    $ret['message'] = $lang['VIRT_ADV_UNREACHEABLE_DATA'] . ' : '.$e->getMessage();
		    $errors[] = $ret;
		}
}

if( $action == 'update_conf' && !empty($fromRequestParams) )
{
    try
    {
        $options = array();

        if( $driver_select == 'vmware' )
        {
            if( isset($savingParams['cluster']))
            {
                $options['cluster'] = $savingParams['cluster'];
            }
            elseif( isset($fromDatabaseParams['cluster']))
            {
                $options['cluster'] = $fromDatabaseParams['cluster'];
            }
        }

    	if ( $is_changed )
    	{
    		if( empty($fromDatabaseParams) )//ADD
    		{
    			if( $virt_type == 'cluster' )
    			{
    				Model_virtualization::setClusterDriver($dbconnection,$node_id,$savingParams['driver']);
    			}
    			Model_virtualization::addAuthenticationParams($dbconnection,$node_id,$savingParams['url'],$savingParams['login'],$savingParams['password'],$savingParams['driver'],$options);
            }
    		else //UPDATE
    		{
    			Model_virtualization::updateAuthenticationParams($dbconnection,$node_id,$savingParams['url'],$savingParams['login'],$savingParams['password'],$savingParams['driver'],$options);
    		}
        }
        if ( $virt_type == 'hypervisor' ) //ADD and UPDATE
        {
            $current_cluster =  NULL;
            $current_nodename = NULL;
            if(!empty($nodes_link))
            {
                $current_cluster = $nodes_link['cluster_id'];
                $current_nodename = $nodes_link['hyperv_name'];
            }
            if( $current_cluster != $cluster_select )
            {
                Model_virtualization::linkNodeToCluster($dbconnection,$node_id,$cluster_select,TRUE);
            }
            if (!empty($nodename_select) && $current_nodename != $nodename_select)
            {
                Model_virtualization::setHypervisorName($dbconnection,$node_id,$nodename_select);
            }
        }

        $is_added = TRUE;
        //$data = Model_virtualization::getVirtAdvanceConfig($dbconnection,$node_id,NULL);
        //$adv_config_id = $data['adv_config']['id'];

        $ret['name'] = '';
        $ret['message'] = $lang['VIRT_ADV_CONFIG_CHANGED'];
        $messages[] = $ret;
        $fromDatabaseParams = Model_virtualization::getAuthenticationParams($dbconnection,$node_id);
    }
    catch(Exception $ex)
    {
        $ret['name'] = 'UNABLE TO SAVE';
        $ret['message'] = $ex->getMessage();
        $errors[] = $ret;
    }
}

if( $is_added && empty($fromDatabaseParams) )//Alors on ajoute un pattern de services
{
    if( $virt_type == 'cluster' )
    {
        $pattern_name = 'default_api_virtcluster';
    }
    else if ($virt_type == 'hypervisor' )
    {
        $pattern_name = 'default_api_hypervisor';
    }
    try
    {
        $pattern = Model_adm::getPatternService($dbconnection,$pattern_name);
        $pattern = array_shift($pattern);
        Model_adm::assignPatternServiceNode($dbconnection,$pattern['id'],$node_id);
    }
    catch(Exception $ex)
    {
        $ret['name'] = 'UNABLE TO ADD PATTERN';
        $ret['message'] = $ex->getMessage();
        $errors[] = $ret;
    }
}

//Préparation de l'affichage
$showedParams = array();

if( empty($fromRequestParams))
{
    $showedParams = $fromDatabaseParams;
    if( !empty($showedParams['password']) )//On cache le mot de passe sauf si il est vide.
    {
        $showedParams['password'] = $password_hidden;
    }
}
else
{
    $showedParams = $fromRequestParams;
}

if( !empty($driver_select) )
{
    $url = $lang['VIRT_ADV_URL_PLACEHOLDER'];
    $node = Model_adm::InstanceNode($dbconnection,$node_id);
    $parse = parse_url($url);
    $parse['host']= $node->getIPAddress();
    if( empty($showedParams['url']) && !empty($parse['host'] && $parse['host'] != '0.0.0.0'))
    {
        $showedParams['url'] = $parse['scheme'] . '://' . $parse['host'] . ':' . $parse['port'];
    }
}

$smarty->assign('virt_type',$virt_type);
$smarty->assign('adv_id',$adv_config_id);
$smarty->assign('node_id',$node_id);

if( $virt_type == 'cluster' )
{
	$driver_list = Model_virtualization::getDriver($dbconnection);
    $driver_print = array();
    foreach($driver_list as $row){
        $driver_print[$row['name']] = $row['name'];
    }

    if( $driver_select == 'vmware' && !empty($fromDatabaseParams['url']) && !empty($fromDatabaseParams['login']) && !empty($fromDatabaseParams['password'] ) )
    {
        $settings = $showedParams;
        $settings['password'] = $fromDatabaseParams['password'];

        $multi_cluster = TRUE;
        $cluster_name = '';
        try
        {
            if( $driver_select != NULL ) $settings['driver'] = $driver_select;
            $cluster = Model_virtualization::getClusterClass($dbconnection,$settings);
            if( $cluster->isVCenter() )
            {
                $cluster_list = $cluster->getClusterList();
            }
            elseif( $cluster->isVcenterAvailable() )
            {
                $ret['name'] = 'NOT VCENTER HOST';
                $ret['message'] = $lang['VIRT_ADV_USE_VCENTER'];
                $errors[] = $ret;
                $multi_cluster = FALSE;
            }
            else
            {
                $multi_cluster = FALSE;
            }
        }
        catch (Exception $e)
        {
            $ret['name'] = 'UNABLE TO GET DATA';
            $ret['message'] = $e->getMessage();
            $errors[] = $ret;
            $cluster_list = array();
        }

        if( isset($settings['cluster'] ) )
        {
            $cluster_name = $settings['cluster'];
        }
        $smarty->assign('multi_cluster',$multi_cluster);
        $smarty->assign('cluster_name',$cluster_name);
        $smarty->assign('cluster_list',$cluster_list);
    }

	$smarty->assign('selected_driver',$driver_select);
	$smarty->assign('driver_list',$driver_print);
	$smarty->assign('driver_added',$is_added);
}
else
{
	$cluster_list = Model_virtualization::getNodebyType($dbconnection,NULL,Model_virtualization::getClusterDeviceType());
	$tmp = array();
    foreach($cluster_list as $cluster)
    {
        $tmp[$cluster->getID()] = $cluster->getName();
    }
    natcasesort($tmp);
    $smarty->assign('cluster_list',$tmp);
	$smarty->assign('selected_cluster',$cluster_select);

    $host_list = array();
    if( !empty($cluster_select) )
    {
        $cluster = Model_virtualization::InstantiateDriver($dbconnection,$cluster_select);
        $host_list = $cluster->getHosts();
    }
    if(  empty($host_list) && $is_added )
    {
        $cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);
        $host_list = $cluster->getHosts();
    }
    if( empty($host_list) && !empty($nodename_select) )
    {
        $host_list[$nodename_select] = $nodename_select;
    }

    if( !empty($host_list))
    {
        $tmp = array();
        foreach($host_list as $host){
            $name = $host->getField('name');
            $tmp[$name] = $name;
        }
        natcasesort($tmp);
        $smarty->assign('nodename_list',$tmp);
        $nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
        $nodes_link = array_shift($nodes_link);
        $nodename_select = $nodes_link['hypervisor_name'];
        $smarty->assign('selected_nodename',$nodename_select);
    }
}

//echo "<pre>"; print_r($showedParams); echo "</pre>";

$smarty->assign('authparam',$showedParams);
$smarty->assign('ERRORS',$errors);
$smarty->assign('ADM_MESSAGE',$messages);
$smarty->display($webp_template);

function getRequestParam($name,$default,$remove=false)
{
	$ret = $default;
	if( isset($_REQUEST[$name]) )
	{
		$ret = $_REQUEST[$name];
	}
	if( $remove && isset($_GET[$name]))
	{
		unset($_GET[$name]);
	}
	return $ret;
}
