<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once 'inc/control/common.php';

$webp_name='WEBP_HYPERVISOR';
$webp_name_path='virtualization';

$webp_model='model_'.$webp_name_path.'.php';
include_once($path.$apache_plugin_path.$webp_model);

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */

include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path."inc/common_lib.php";
session_write_close();

$plugin_template_path = "$path.$apache_plugin_path/templates/";
$error_messages = array();
try{
	if( $action == 'addServices')
	{
		if(!$user->getAccess($dbconnection,"esia_device")||!$user->getAccess($dbconnection,"esia_administration"))
		{
			$smarty->display('no_access.html');
			exit(0);
		}

		$checks=$_GET;

		unset($checks["id"]);
		unset($checks["nodeid"]);
		unset($checks["action"]);
		unset($checks["options"]);
		unset($checks["server"]);
		unset($checks["check"]);

		$node=Model_esia::InstanceNode($dbconnection,$node_id);
		$services = Model_esia::getServices($dbconnection,$node->getId());
		$plugin=Model_esia::getPlugin($dbconnection,$_GET["check"])[0];
		foreach($checks as $key => $value){
			if (is_array( $value ) ) $value = array_shift($value);
			$checks[$key] = $_GET["options"];
			$checks[$key]=str_replace('<storage>', $value,$checks[$key]);

			$plugin_name = $plugin["name"];
			$plugin_name = "STORAGE";

			if(empty($_GET["common"])) $name = "$plugin_name $value";
			else $name=$_GET["common"]." ".$key;
			if(! search_services($name,$services))
			{
				Model_adm::addService($dbconnection, $name, $plugin["id"], $node->getId(), $plugin["interval_time"], $checks[$key], $plugin["priority"],null,null);
			}
		}
 //   }
	header('Location: '.$_SERVER['SCRIPT_NAME']."?nodeid=$node_id");
	exit(0);
	}

	if( !is_object($node))
	{
		$node = Model_adm::InstanceNode($dbconnection,$node_id);
	}

	if(	$user->getDroits($dbconnection,"virtualization_access",$node->getName()) !=1
		|| $user->getDroits($dbconnection,"device_view",$node->getName()) !=1
		)
	{
		$smarty->display('no_access.html');
		exit(0);
	}

	$device_type = $node->getType();
	if( $device_type == Model_virtualization::getClusterDeviceType() )
	{
		$virt_type = 'cluster';
	}
	else
	{
		$virt_type = 'hypervisor';
	}

	$auth_params =  Model_virtualization::getAuthenticationParams($dbconnection,$node_id);
	$resources['drv_name'] = $driver = $auth_params['driver'];

	if($tab=='servicestate')
	{
		$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);
		$status = "up";

	    $host_list = $cluster->getHosts();

	    $host_list_arr = array();
	    $current_host_arr = NULL;
	    $current_host_obj = NULL;
	    foreach($host_list as $host)
	    {
			$ret['name'] = $host->getName();
			$ret['status'] = $host->isAlive();
			$ret['address'] = $host->getAddress();
			$ret['cpu_usage'] = round(100*$host->getCpusUsage());
			$ret['cpu_total'] = $host->getCpusTotal();
			$ret['cpu_percent'] = $ret['cpu_usage'];
			$ret['cpu_message'] = $ret['cpu_usage'].'% /' . $ret['cpu_total']. ' CPU(s)';
			$ret['cpu_status'] = getStatus($ret['cpu_percent']);

			$mem = bytesToHuman($host->getMemUsage(),$host->getMemTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$ret['mem_usage'] = $usage;
			$ret['mem_total'] = $total;
			$ret['mem_unit']  = $unit;
			$ret['mem_percent'] = $mem['percent']['usage'];
			$ret['mem_message'] = "$usage $unit / $total $unit";
			$ret['mem_status'] = getStatus($ret['mem_percent']);
			$ret['uptime'] = parseUptime($host->getUpTime());
			$host_list_arr[$ret['name']] = $ret;
	    }
	    ksort($host_list_arr,SORT_NATURAL);
	    $vm_list_obj = $cluster->getVMs();
	    $templates = count($cluster->getTemplates());


	    $vm_stats['running']=0;
	    $vm_stats['paused']=0;
	    $vm_stats['stopped']=0;
		$vm_stats['total'] = 0;
	    $vm_stats['locked']=0;
	    $vm_stats['template']= $templates;

	    foreach($vm_list_obj as $vm)
	    {
	        $state = $vm->getState();
	        $vm_stats[$state]++;
	        if( $vm->isLocked() ) $vm_stats['locked']++;
			$vm_stats['total']++;
	    }
	    $smarty->assign('vm_stats',$vm_stats);
		$smarty->assign('host_list',$host_list_arr);

		if( $virt_type == 'cluster')
		{
			$resources['type'] = $lang['VIRT_TYPE_CLUSTER'];
		    $resources['name'] = $cluster->getName();

			$cpu_usage = round($cluster->getCpusUsage()*100);
			$cpu_total = $cluster->getCpusTotal();

		    $resources['cpu_percent'] = $cpu_usage;
		    $resources['cpu_name']    = 'CPU';
		    $resources['cpu_message'] = "$cpu_usage% / $cpu_total CPU(s)";

			$mem = bytesToHuman($cluster->getMemUsage(),$cluster->getMemTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
		    $resources['ram_percent'] = $mem['percent']['usage'];
		    $resources['ram_name']    = 'RAM';
		    $resources['ram_message'] = "$usage $unit / $total $unit";

			$sr_type = 'SHARED';
			$storages = $cluster->getStorages(TRUE);
			if( empty($storages))
			{
				$storages = $cluster->getStorages(FALSE);
				$sr_type = 'LOCAL';
			}

			$sr_usage = 0;
			$sr_total = 0;
			foreach($storages as $storage)
			{
				$sr_usage += $storage->getSizeUsed();
				$sr_total += $storage->getSizeTotal();
			}
			$sr = bytesToHuman($sr_usage,$sr_total);

			$usage = $sr['human']['usage'];
			$total = $sr['human']['total'];
			$unit  = $sr['human']['unit'];
		    $resources['sr_percent'] = $sr['percent']['usage'];
			if( $sr_type = 'SHARED')
			{
		    	$resources['sr_name']    = $lang['VIRT_STORAGES_SHARED'];
			}
			else
			{
				$resources['sr_name']    = $lang['VIRT_STORAGES_LOCAL'];
			}
		    $resources['sr_message'] = "$usage $unit / $total $unit";

			foreach($host_list as $host)
			{
				if( !$host->isAlive() )
				{
					$status = "down";
				}
			}
		    $resources['status_value']      = $status;

			if( $cluster->isCluster())
			{
				$resources['clustered_value']   = $lang['VIRT_YES'];
			}
			else
			{
				$resources['clustered_value']   = $lang['VIRT_NO'];
			}

			if( $cluster->isHA())
			{
				$resources['ha_value']   = $lang['VIRT_YES'];
			}
			else
			{
				$resources['ha_value']   = $lang['VIRT_NO'];
			}

				$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
				$byNodenameLink = array();
				foreach($nodes_link as $row)
				{
						$byNodenameLink[$row['hypervisor_name']] = $row;
				}

				foreach($host_list_arr as $key => $row)
				{
						if(isset($byNodenameLink[$row['name']]))
						{
								$id = $byNodenameLink[$row['name']]['device_id'];
								$page = model_esia::getPageControl($dbconnection,Model_virtualization::getHypervisorDeviceType());
								//Rempalcer :id par l'id correspondant pour la page de contrôle
								$pattern = "/:id/";
								$urlnode = preg_replace($pattern,$id,$page);
								$host_list_arr[$key]['page'] = $urlnode;
								$host_list_arr[$key]['update'] = "./administration.php?admin=device&amp;action=modif&amp;id=$id";
						}
						else
						{
								$host_list_arr[$key]['page'] = NULL;

								$virt_params[]='cluster_id='.$node_id;
								$virt_params[]='name='.urlencode($row['name']);
								$virt_params[]='address='.urlencode($row['address']);
								$host_list_arr[$key]['add'] = "$apache_plugin_path/adv_device_add.php?admin=device&amp;action=create";
								$host_list_arr[$key]['add'] .= '&' .implode('&',$virt_params);
						}
				}

				$smarty->assign('host_list',$host_list_arr);
		}
		else
		{
			$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
			if( count($nodes_link) == 1)
			{
				$nodes_link = array_shift($nodes_link);
				if(isset( $nodes_link['hypervisor_name']))
				{
					$hypervisorName = $nodes_link['hypervisor_name'];
				}

				$current_host_obj = NULL;
				foreach($host_list as $host){
					if($host->getName() == $hypervisorName)
					{
						$current_host_arr = $host_list_arr[$hypervisorName];
						$current_host_arr['os'] = $host->getOS();

						$netin = $host->getNetInUsage();
						$netin = bytesToHuman($netin,$netin,TRUE);
						$netin = $netin['human']['usage'] . ' ' .  $netin['human']['unit'].'/s';

						$netout = $host->getNetOutUsage();
						$netout = bytesToHuman($netout,$netout,TRUE);
						$netout = $netout['human']['usage'] . ' ' .  $netout['human']['unit'].'/s';

						$current_host_arr['net_in'] = $netin;
						$current_host_arr['net_out'] = $netout;
						$current_host_obj = $host;
						$vm_list_obj = $host->getVMs();
						break;
					}
				}
			}

			$id = $nodes_link['cluster_id'];
			$page = model_esia::getPageControl($dbconnection,Model_virtualization::getClusterDeviceType());
			//Rempalcer :id par l'id correspondant pour la page de contrôle
			$pattern = "/:id/";
			$urlnode = preg_replace($pattern,$id,$page);
			$resources['page'] = $urlnode;


			$vm_stats['running']=0;
			$vm_stats['paused']=0;
			$vm_stats['stopped']=0;
			$vm_stats['total'] = 0;
			foreach($vm_list_obj as $vm)
			{
				$state = $vm->getState();
				$vm_stats[$state]++;
				$vm_stats['total']++;
			}


			$resources['type'] = $lang['VIRT_TYPE_HYPERVISOR'];
			$resources['name'] = $current_host_obj->getName();

			$cpu_usage = round($current_host_obj->getCpusUsage()*100);
			$cpu_total = $current_host_obj->getCpusTotal();

			$resources['cpu_percent'] = $cpu_usage;
			$resources['cpu_name']    = 'CPU';
			$resources['cpu_message'] = "$cpu_usage% / $cpu_total CPU(s)";

			$mem = bytesToHuman($current_host_obj->getMemUsage(),$current_host_obj->getMemTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$resources['ram_percent'] = $mem['percent']['usage'];
			$resources['ram_name']    = 'RAM';
			$resources['ram_message'] = "$usage $unit / $total $unit";

			$storages = $cluster->getStorages(NULL);

			$sr_usage = 0;
			$sr_total = 0;
			foreach($storages as $storage)
			{
				$hosts = Model_virtualization::objToArray($storage->getHosts(),'name');
				$tmp = array();
				foreach($hosts as $host)
				{
					$tmp[] = $host['name'];
				}

				if( !in_array($hypervisorName,$tmp))
				{
					continue;
				}
				$sr_usage += $storage->getSizeUsed();
				$sr_total += $storage->getSizeTotal();
			}
			$sr = bytesToHuman($sr_usage,$sr_total);

			$usage = $sr['human']['usage'];
			$total = $sr['human']['total'];
			$unit  = $sr['human']['unit'];
			$resources['sr_percent'] = $sr['percent']['usage'];
			$resources['sr_name']    = $lang['VIRT_STORAGES'];
			$resources['sr_message'] = "$usage $unit / $total $unit";
			$smarty->assign('vm_host',$vm_stats);
			$smarty->assign('current_host',$current_host_arr);
		}
	}
	elseif($tab=='storage'){
		$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);

		if( $virt_type == 'hypervisor')
		{
			$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
			$nodes_link = array_shift($nodes_link);
			$hypervisorName = NULL;
			if(isset( $nodes_link['hypervisor_name']))
			{
				$hypervisorName = $nodes_link['hypervisor_name'];
			}
		}

		$storages = array();
		if ( $virt_type == 'cluster' || $hypervisorName != NULL)
		{
			$storages = $cluster->getStorages();
		}

		$storages_output = array();
		foreach( $storages as $storage)
		{
			$retRow = array();

			$hosts = Model_virtualization::objToArray($storage->getHosts(),'name');
			$tmp = array();
			foreach($hosts as $host)
			{
				$tmp[] = $host['name'];
			}

			if( $virt_type == 'hypervisor'  && !in_array($hypervisorName,$tmp))
			{
				continue;
			}

			$retRow['id'] = $storage->getID();
			$retRow['name'] = $storage->getName();
			$retRow['type'] = $storage->getType();
			$retRow['content'] = $storage->getContent();
			$retRow['shared'] = $storage->isShared();

			$retRow['server'] = implode(',',$tmp);

		//	$retRow['disk_read'] = $storage->getDiskRead();
		//	$retRow['disk_write'] = $storage->getDiskWrite();
		//	$retRow['size_usage'] = $storage->getSizeUsed();
		//	$retRow['size_virtual'] = $storage->getSizeVirtual();
		//	$retRow['size_total'] = $storage->getSizeTotal();
		//	$retRow['nb_volumes'] = count($storage->getVolumes());

			$mem = bytesToHuman($storage->getSizeUsed(),$storage->getSizeTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$percent  = $mem['percent']['usage'];
			//			$retRow['memory'] = "$percent % ($usage $unit / $total $unit)";
			$retRow['disk_status'] = getStatus($percent);
			$retRow['disk_raw'] = $mem['raw']['usage'];
			$retRow['disk_percent'] = "$percent";
			$retRow['disk_bytes'] = "$usage $unit / $total $unit";

			$storages_output[] = $retRow;
		}
	/*
		echo "<pre>";
		print_r($storages_output);
		echo "</pre>";
		exit(0);
	*/

		$commonName = Model_esia::getCommonName($lang, "CHECK_API_STORAGE_USAGE", "CHECK_API_STORAGE_USAGE");
		$plugin_fields = array_shift(Model_esia::getPlugin($dbconnection,'CHECK_API_STORAGE_USAGE'));
		$parameters = $plugin_fields['parameter'];
		$smarty->assign('admin_checks',array(
		    'check' => 'CHECK_API_STORAGE_USAGE',
		    'common'=>$commonName,
		    'default'=>$parameters
		));


	    $smarty->assign('admin_simplify',array(
	                   'check' => 'CHECK_DB_BACKUPS',
	                   'common'=>$commonName,
	                   'default'=>$parameters
	    ));


		$smarty->assign('disk_array', $storages_output);
	}
	elseif($tab=='vm'){
		$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);
		if( isset($_REQUEST['action']))
		{
			$action = $_REQUEST['action'];
			$vmid = NULL;
			$vm = NULL;
			if(isset($_REQUEST['vmid']))
			{
				if(in_array($action,array('vm_start','vm_restart','vm_stop')) && $user->getDroits($dbconnection,"virtualization_vm_action",$node->getName()) !=1)
				{
					$error_messages[] = $lang['BAD_ACCES'];
				}
				else
				{
					$vmid = $_REQUEST['vmid'];
					$vm = $cluster->getVM($vmid);
					$name = $vm->getName();

					$message = "VM $name ";

					if( $action == 'vm_start' )
					{
						$vm->start();

						if(waitVM($cluster,$vmid,'running',10))
						{
							$success_message.= $message . $lang['VM_START_SUCCESS'];
						}
					}
					elseif( $action == 'vm_restart' )
					{
						$vm->reboot(FALSE);
						if(waitVM($cluster,$vmid,'running',10))
						{
							$success_message.= $message . $lang['VM_RESTART_SUCCESS'];
						}
					}
					elseif ($action == 'vm_stop' )
					{
						$vm->shutdown(FALSE);
						if(waitVM($cluster,$vmid,'stopped',10))
						{
							$success_message.= $message . $lang['VM_STOP_SUCCESS'];
						}
					}
				}
			}
		}
		if( $virt_type == 'hypervisor')
		{
			$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
			$nodes_link = array_shift($nodes_link);
			$hypervisorName = NULL;
			if(isset( $nodes_link['hypervisor_name']))
			{
				$hypervisorName = $nodes_link['hypervisor_name'];
			}
		}

		$data = array();
		if ( $virt_type == 'cluster' || $hypervisorName != NULL)
		{
			$data = $cluster->getVMs();
		}

		$vm_output = array();
		foreach( $data as $vm)
		{
			$retRow = array();

			$host = $vm->getHost();
			$host_name = '';
			if( is_object($host))
			{
				$host_name = $host->getName();
			}
			if( $virt_type == 'hypervisor'  && !empty($host_name) && $hypervisorName != $host_name)
			{
				continue;
			}

			$retRow['vmid'] = $vm->getID();
			$retRow['name'] = $vm->getName();
			$retRow['status'] = $vm->getState();
			$retRow['isHA'] = $vm->isHA();
			$retRow['islocked'] = $vm->isLocked();
			if( $retRow['islocked'] )
			{
				$retRow['locked'] = $vm->getLockStatus();
			}
			$retRow['uptime_raw'] = $vm->getUpTime();
			$retRow['uptime'] = parseUptime($retRow['uptime_raw'],2);
			$retRow['node'] = $host_name;

			$cpu = round($vm->getCpusUsage() * 100,0);
			$cpu_nb = $vm->getCpusTotal();
	//		$retRow['cpu'] = "$cpu % (Total : $cpu_nb)";
			$retRow['cpu_percent'] = "$cpu";
			$retRow['cpu_total'] = "$cpu_nb";
			$retRow['cpu_status'] = getStatus($retRow['cpu_percent']);

			$mem = bytesToHuman($vm->getMemUsage(),$vm->getMemTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$percent  = $mem['percent']['usage'];
//			$retRow['memory'] = "$percent % ($usage $unit / $total $unit)";
			$retRow['mem_percent'] = "$percent";
			$retRow['mem_status'] = getStatus($retRow['mem_percent']);
			$retRow['mem_raw'] = $mem['raw']['usage'];
			$retRow['mem_bytes'] = "$usage $unit / $total $unit";
			$retRow['actions'] = '';
			$vm_output[] = $retRow;
		}
	/*
		echo "<pre>";
		print_r($vm_output);
		echo "</pre>";
		exit(0);
		*/
		$smarty->assign('vm_array', $vm_output);
	}
	elseif($tab=='host'){
		$cluster = Model_virtualization::InstantiateDriver($dbconnection,$node_id);
		$data = $cluster->getHosts();

		$host_output=array();

		$nodes_link = Model_virtualization::getClusterNodesLink($dbconnection,$node_id);
		$byNodenameLink = array();
		foreach($nodes_link as $row)
		{
				$byNodenameLink[$row['hypervisor_name']] = $row;
		}

		foreach($data as $obj)
		{
			$retRow = array();
			$retRow['id'] 		= $obj->getID();
			$retRow['name'] 	= $obj->getName();
			$retRow['alive']	= $obj->isAlive();
			$retRow['address'] 	= $obj->getAddress();
			$retRow['uptime_raw'] = $obj->getUpTime();
			$retRow['uptime'] 	= parseUptime($retRow['uptime_raw'],2);

			$cpu = round($obj->getCpusUsage() * 100,0);
			$cpu_nb = $obj->getCpusTotal();
	//		$retRow['cpu'] = "$cpu % (Total : $cpu_nb)";
			$retRow['cpu_percent'] = "$cpu";
			$retRow['cpu_total'] = "$cpu_nb";
			$retRow['cpu_status'] = getStatus($retRow['cpu_percent']);

			$mem = bytesToHuman($obj->getMemUsage(),$obj->getMemTotal());
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$percent  = $mem['percent']['usage'];
//			$retRow['memory'] = "$percent % ($usage $unit / $total $unit)";
			$retRow['mem_percent'] = "$percent";
			$retRow['mem_raw'] = $mem['raw']['usage'];
			$retRow['mem_bytes'] = "$usage $unit / $total $unit";
			$retRow['mem_status'] = getStatus($retRow['mem_percent']);

			$netin = $obj->getNetInUsage();
			$retRow['net_in_raw'] = $netin;

			$netin = bytesToHuman($netin,$netin,TRUE);
			$netin = $netin['human']['usage'] . ' ' .  $netin['human']['unit'].'/s';

			$netout = $obj->getNetOutUsage();
			$retRow['net_out_raw'] = $netout;
			$netout = bytesToHuman($netout,$netout,TRUE);
			$netout = $netout['human']['usage'] . ' ' .  $netout['human']['unit'].'/s';

			$retRow['net_in'] = $netin;
			$retRow['net_out'] = $netout;

			$retRow['running_vms'] = 0;
			$vms = $obj->getVMs();
			$main_key = 'top_cpu';
			$vm_stats[$main_key]['ratio']=0;
			$vm_stats[$main_key]['usage']=0;
			$vm_stats[$main_key]['total']=0;
			$vm_stats[$main_key]['name']='';

			$main_key = 'top_mem';
			$vm_stats[$main_key]['ratio']=0;
			$vm_stats[$main_key]['usage']=0;
			$vm_stats[$main_key]['total']=0;
			$vm_stats[$main_key]['name']='';

			foreach($vms as $vm)
			{
				if( $vm->isAlive())
				{
					$retRow['running_vms']++;

					$cpu = $vm->getCpusUsage();
					$cpu_nb = $vm->getCpusTotal();
					$ratio = $cpu * $cpu_nb;

					$cpu = round($cpu * 100,0);
					$main_key = 'top_cpu';
					if( $vm_stats[$main_key]['ratio'] < $ratio)
					{
						$vm_stats[$main_key]['ratio']=$ratio;
						$vm_stats[$main_key]['usage']=$cpu;
						$vm_stats[$main_key]['total']=$cpu_nb;
						$vm_stats[$main_key]['name']=$vm->getName();
					}

					$mem_usage = $vm->getMemUsage();
					$mem_total = $vm->getMemTotal();
					$ratio = $mem_usage;

					$main_key = 'top_mem';
					if( $vm_stats[$main_key]['ratio'] < $ratio)
					{
						$vm_stats[$main_key]['ratio']=$ratio;
						$vm_stats[$main_key]['usage']=$mem_usage;
						$vm_stats[$main_key]['total']=$mem_total;
						$vm_stats[$main_key]['name']=$vm->getName();
					}
				}
			}

			$main_key = 'top_cpu';
			$cpu = $vm_stats[$main_key]['usage'];
			$cpu_nb = $vm_stats[$main_key]['total'];
			$cpu_vm_name = $vm_stats[$main_key]['name'];
			//$retRow[$main_key] = "$cpu % / $cpu_nb total (VM : $cpu_vm_name)";
			$retRow[$main_key] = "$cpu_vm_name ($cpu% / $cpu_nb total)";
			$retRow['top_cpu_raw'] = $vm_stats[$main_key]['ratio'];

			$main_key = 'top_mem';
			$mem = bytesToHuman($vm_stats[$main_key]['usage'],$vm_stats[$main_key]['total']);
			$usage = $mem['human']['usage'];
			$total = $mem['human']['total'];
			$unit  = $mem['human']['unit'];
			$percent  = $mem['percent']['usage'];
			$mem_vm_name = $vm_stats[$main_key]['name'];
	//		$retRow['top_mem'] = "$percent % ($usage $unit / $total $unit VM : $mem_vm_name)";
			$retRow['top_mem'] = "$mem_vm_name ($usage $unit / $total $unit : $percent%)";
			$retRow['top_mem_raw'] = $vm_stats[$main_key]['ratio'];

			if(isset($byNodenameLink[$retRow['name']]))
			{
				$id = $byNodenameLink[$retRow['name']]['device_id'];
				$page = model_esia::getPageControl($dbconnection,Model_virtualization::getHypervisorDeviceType());
				//Rempalcer :id par l'id correspondant pour la page de contrôle
				$pattern = "/:id/";
				$urlnode = preg_replace($pattern,$id,$page);
				$retRow['page'] = $urlnode;
			}
			else
			{
				$retRow['page'] = NULL;
			}

			$host_output[] = $retRow;
		}
	/*
			echo "<pre>";
			print_r($host_output);
			echo "</pre>";
			exit(0);
			*/
		$smarty->assign('host_array', $host_output);
	}
}
catch(Exception $ex)
{
	$error_messages[] = $ex->getMessage();
}
$smarty->assign('resources',$resources);
$smarty->assign('error_messages',$error_messages);
$smarty->assign('virt_type',$virt_type);
$smarty->assign('template_path',$plugin_template_path);

$smarty->assign('webplugin_path',$apache_plugin_path);

if( !empty($success_message))
{
	$smarty->assign('success_message',$success_message);
}

$licence = Model_Adm::getLicenceInformation($dbconnection);
$action_licence = (!empty($licence['type']) && strtoupper($licence['type']) == 'MERCURY' );
$action_permit = ($user->getDroits($dbconnection,"virtualization_vm_action",$node->getName()) ==1);
$action_supported = in_array($driver,array('xenserver','proxmox'));
$action_granted = ($action_permit && $action_licence && $action_supported);

$smarty->assign('action_granted',$action_granted);
$smarty->assign('admin_granted',$user->getDroits($dbconnection,"esia_device") == 1);


$smarty->display($plugin_template_path.'control_virtualization.html');

function search_services($name,$arr)
{
	foreach($arr as $service)
	{
		$match ='#'.$name.'#';
		if(preg_match($match,$service['name']))
		{
			return true;
		}
	}
	return false;
}
